import numpy as np
import matplotlib.pyplot as plt
import time

import threading

import gravity
#import gravity_cy as gravity

from run_gravity import compute_orbit

def main():
    planet_1 = gravity.Planet()
    planet_2 = gravity.Planet()
    planet_2.x = 0.7

    N = 1000

    positions = np.zeros((N, 3, 2))

    def run_planet(planet, planet_idx):
        positions[:,:,planet_idx] = compute_orbit(planet)

    thread_1 = threading.Thread(target=run_planet, args=(planet_1, 0))
    thread_2 = threading.Thread(target=run_planet, args=(planet_2, 1))

    start_time = time.time()

    thread_1.start()
    thread_2.start()

    thread_1.join()
    thread_2.join()

    print "Took:", time.time() - start_time

    plt.plot(positions[:,0,0], positions[:,1,0], 'b-')
    plt.plot(positions[:,0,1], positions[:,1,1], 'g-')
    plt.plot([0], [0], 'y*', ms=20)
    plt.axis('equal')
    plt.show()

if __name__ == "__main__":
    main()
