/*
    Anagrammimylly: an anagram generator
    Copyright (C) 1998-2000 Pauli Virtanen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/*
 * A simple wordlist, STLish implementation.
 */
#ifndef WORDLIST_H
#define WORDLIST_H

#ifdef __cplusplus
extern "C" {
#endif

#define free_ifneed(var) {if (var != NULL) { free(var); var = NULL; }}

        typedef enum { failure=0, success } success_t;

        typedef struct
        {
                char *word;
                char *end;
        } word_t;
        
        typedef struct
        {
                word_t *begin;
                word_t *end;

                word_t *alloc_end;
        } wordlist_t;

        unsigned long wl_get_count(wordlist_t *);

        success_t wl_load(wordlist_t *wordlist, char *);
        success_t wl_save(wordlist_t *wordlist, char *);
        void wl_unload(wordlist_t *wordlist);
        success_t wl_add_word(wordlist_t *wordlist, char *);
        success_t wl_remove(wordlist_t *wordlist, word_t *w);
        word_t *wl_find_word(wordlist_t *wordlist, char *word);

#ifdef __cplusplus
}
#endif

#endif
